﻿import globalPluginHandler
import speech
import speechViewer
import ui
import os

start = False
oldSpeak = speech.speak
contents = ''

def getSequenceText(sequence):
  return speechViewer.SPEECH_ITEM_SEPARATOR.join([x for x in sequence if isinstance(x, str)])

def mySpeak(sequence, *args, **kwargs):
  global contents
  oldSpeak(sequence, *args, **kwargs)
  text = getSequenceText(sequence)
  if text:
    if '\n' not in text:
      text += '\n'
    contents += text

class GlobalPlugin(globalPluginHandler.GlobalPlugin):
  def script_record(self, gesture):
    global start
    start = not start
    if not start:
      speech.speak = oldSpeak
      global contents
      with open('C:\\users\\' + os.getlogin() + '\\desktop\\NVDA.txt', 'w') as file:
        file.write(contents.replace('\r\n', '\n'))
      contents = ''
      ui.message("停止紀錄")
    else:
      ui.message("開始紀錄")
      speech.speak = mySpeak

  script_record.__doc__ = _('NVDARecorder')

  __gestures = { "kb:alt+numpadplus":"record" }
